// champ.sci
// Ce programme est une production mathmatique franaise.
// 
// Stphane Grognet, Laboratoire de Mathmatiques Jean Leray de l'Universit de Nantes, UMR 6629, France ;
// Jean-Franois Petiot, IRCCyN, UMR 6597, cole Centrale de Nantes, France.
//
// Bricoler le stockage temporaire des paramtres ;
// calculer le champ de vecteurs prfrences V
// en fonction de la matrice de prfrences P, du paramtre a de partition de l'unit,
// et de la matrice des points A.
//
function parametres=param(a,R,c,N,seuil,alpha,chi)
//
// astuces pour le stockage
//
paramvide=unix_g("rm ../RNT/Parametres") ;
prefmvide=unix_g("rm ../RNT/Preferences") ;
Dvide=unix_g("rm ../RNT/DistancesBrutes") ;
Evide=unix_g("rm ../RNT/DistancesRealisees") ;
Avide=unix_g("rm ../RNT/Sommets") ;
parametres=['a = '+string(a);'R = '+string(R);'c = '+string(c);'N = '+string(N);
'seuil = '+string(seuil);'size(A) = ! '+string(size(A,1))+'  '+string(size(A,2))+' ! ';'alpha = '+string(alpha);'chi = '+string(chi);] ;
//
// stockage temporaire des paramtres
//
write('../RNT/Parametres',parametres) ;
write('../RNT/Preferences',P) ;
write('../RNT/DistancesBrutes',D) ;
write('../RNT/DistancesRealisees',E) ;
write('../RNT/Sommets',A) ;
endfunction ;
//
// LE CHAMP
//
exec("polarisation.sci",-1) ; 
exec("convexe.sci",-1) ;
exec("cadrage.sci",-1) ;
//
function y=V(a,R,c,N,seuil,A,B,x)
X=A(:,1)-A(:,1) ;
s=size(A,2) ;
for i=1:s-1 ,
 ii=i+1 ;
 for j=ii:s ,
  XX=A(:,j)-A(:,i)
  X=X+annulation(a,R,A,i,j,x)*(B(i,j)/(norm(XX))^2)*XX
 end;
end;
//
// le champ s'annule  l'infini et en fait ds qu'on s'loigne de l'enveloppe convexe de A et des artes de A
// l'crasement en-dehors du convexe tient compte des itrations
// 
if norm(X)<seuil then confinement=0 ;
 else conf1=max([1,1/c]) ; conf=conf1*2^(s*s) *distconv(A,x)/R ; confinement=psi(R,c,A,x)/cosh(conf) ; 
end ;
y=X * confinement ;
endfunction ;





